/*
 * Copyright (C) 2002  Pekka Enberg <Pekka.Enberg@cs.helsinki.fi>
 *
 * Distributed under the terms of the GNU General Public License
 * version 2 or later.
 */
#ifndef _BUFFER_H_
#define _BUFFER_H_ 1

#include <stdbool.h>
#include <stdio.h>
#include <stddef.h>

/* Buffer used to hold XML stream.  */
struct buffer {
    char * data;
    size_t length;
    size_t capacity;
};

void buffer_init(struct buffer * buffer, size_t initial_capacity);
void buffer_release(struct buffer * buffer);
void buffer_push(struct buffer * buffer, const char * text);
int buffer_pop(struct buffer * buffer);
void buffer_flush(struct buffer * buffer, FILE * output);

#endif
